Only in snd-8-new: a.out
Only in snd-8-new: config.h
Only in snd-8-new: config.log
Only in snd-8-new: config.status
diff -ur snd-8/eval-c.scm snd-8-new/eval-c.scm
--- snd-8/eval-c.scm	2006-03-29 06:57:57.000000000 -0800
+++ snd-8-new/eval-c.scm	2006-03-30 00:25:15.000000000 -0800
@@ -717,6 +717,7 @@
 
 (define (eval-c-parse-line term)
   (if (and (string? term)
+	   (not (string=? "" term))
 	   (eq? #\# (string-ref term 0)))
       (<-> term (string #\newline))
       (<-> (eval-c-parse term) ";" (string #\newline))))
Only in snd-8-new: eval-c.scm~
Only in snd-8-new: makefile
Only in snd-8-new/po: de.gmo
Only in snd-8-new/po: Makefile
Only in snd-8-new/po: Makefile.in
Only in snd-8-new/po: POTFILES
diff -ur snd-8/rt-compiler.scm snd-8-new/rt-compiler.scm
--- snd-8/rt-compiler.scm	2006-03-29 06:57:57.000000000 -0800
+++ snd-8-new/rt-compiler.scm	2006-03-30 00:11:03.000000000 -0800
@@ -1391,7 +1391,7 @@
        (let ((newname (get-unique-name (legalize-c-name name))))
 	 (if is-guile-var
 	     (set! renamed-guile-vars (cons (list name newname) renamed-guile-vars)))
-	 (if is-guile-var
+	 (if (and rt-verbose is-guile-var)
 	     (c-display "Variable" name "renamed as" newname))
 	 (hashq-set! all-renamed-variables newname #t)
 	 newname))
diff -ur snd-8/snd_conffile.scm snd-8-new/snd_conffile.scm
--- snd-8/snd_conffile.scm	2006-03-29 06:57:57.000000000 -0800
+++ snd-8-new/snd_conffile.scm	2006-03-30 00:11:03.000000000 -0800
@@ -1835,30 +1835,44 @@
 
       
       ;;(set! (widget-size (car (sound-widgets (car current-buffer)))) (list 1000 1000) )
-      
+      (define position 0)
+      ;;(define num 0)
       (define (c-open-buffer filename)
-	"(c-open-buffer filename) adds a menu item that will select filename (use with open-hook)"
 	(if (c-isloaded? filename)
 	    (begin
 	      (c-switch-to-buf filename)
 	      #t)
-	    (let ((was-starting-up? *c-is-starting-up*))
+	    (letrec ((was-starting-up? *c-is-starting-up*)
+		     (is-in-menu? (member filename c-sounds-in-menu))
+		     (add-buffer-menu (lambda (position addstar?)
+					(let ((gen-filename filename ));; (let ((ret (string-append (number->string num) " " filename))) (set! num (1+ num)) ret)))
+					  (add-to-menu buffer-menu 
+						       gen-filename
+						       (lambda ()
+							 (if was-starting-up?
+							     (begin
+							       ;;(c-display "here")
+							       (c-remove-sounds-in-menu filename)
+							       (remove-from-menu buffer-menu gen-filename)
+							       (open-sound filename))
+							     (begin
+							       ;;(c-display "not here")
+							       (remove-from-menu buffer-menu gen-filename)
+							       (add-buffer-menu position #t)
+							       (c-switch-to-buf filename))))
+						       position)))))
 	      (if *c-is-starting-up*
 		  (set! c-sounds-in-menu (cons filename c-sounds-in-menu)))
-	      (add-to-menu buffer-menu 
-			   filename
-			   (lambda ()
-			     (if was-starting-up?
-				 (begin
-				   (c-remove-sounds-in-menu filename)
-				   (remove-from-menu buffer-menu filename)
-				   (open-sound filename))
-				 (c-switch-to-buf filename))))
+	      (add-buffer-menu position #f)
+	      ;;(c-display "position" position)
+	      (if (not was-starting-up?)
+		  (set! position (1+ position)))
 	      *c-is-starting-up*)))
 
       (define (c-close-buffer snd)
 	"(close-buffer snd) removes the menu item associated with snd (use with close-hook)"
 	(let ((filename (file-name snd)))
+	  ;;(remove-from-menu buffer-menu (string-append "* " filename))
 	  (remove-from-menu buffer-menu filename)
 	  (remove-from-menu buffer-menu filename)
 	  (c-remove-sounds-in-menu filename))
@@ -2087,7 +2101,610 @@
 ;; Load GTK mnemonics code from Maxim Krikun.
 (load-from-path "kmenu.scm")
 
- 
+
+
+;;##############################################################
+;; Load rt-player. Takes some time.
+;;##############################################################
+
+;;(load-from-path "rt-player.scm")
+
+
+#!
+(load-from-path "rt-player.scm")
+!#
+
+(if (not (provided? 'snd-rt-compiler.scm))
+    (load-from-path "rt-compiler.scm"))
+
+(if (not (defined? '*rt-reader-buffer-time*))
+    (define-toplevel '*rt-reader-buffer-time* 5)) ;; Number of seconds to buffer.
+
+(define *rt-use-rt-player* #t)
+
+
+
+;; RB2 (ringbuffer 2)
+
+;; VCT caching. Really necessary because of the large amount of memory data being allocated. The garbage collector can't collect fast enough the huge amount of vct-data that
+;; must be obtained when clicking play rapidly. At least, I think thats what happening. The result is something that seems very much like a swapping hell that
+;; eventually can cause a freeze of the machine.
+(define rb2-buffer '())
+(define (rb2-return-buffer v)
+  (if (and (not (null? rb2-buffer))
+	   (= (vct-length v) (vct-length (car rb2-buffer))))
+      (set! rb2-buffer (cons v rb2-buffer))
+      (set! rb2-buffer (list v))))	  
+(define (rb2-get-buffer size)
+  (if (null? rb2-buffer)
+      (make-vct size)
+      (if (= (vct-length (car rb2-buffer)) size)
+	  (let ((ret (car rb2-buffer)))
+	    (set! rb2-buffer (cdr rb2-buffer))
+	    ret)
+	  (begin
+	    (set! rb2-buffer '())
+	    (make-vct size)))))
+	 
+(define (make-rb2 ch size reader)
+  (let ((ret (vector (rb2-get-buffer size)
+		     (rb2-get-buffer size)
+		     (make-var size) ;; read-pos
+		     (make-var size) ;;size
+		     (make-var 1) ;; curr-ringbuffer-num. Just finished with last position at the second vct.
+		     (make-ringbuffer 64)
+		     (make-var 0))))
+    ;;(c-display "reading num 0")
+    (reader (vector-ref ret 0))
+    (ringbuffer-get (vector-ref ret 5)
+		    (lambda (ringbuf-num)
+		      ;;(c-display "reading num" ch ringbuf-num)
+		      (reader (vector-ref ret (c-integer ringbuf-num)))
+		      (write-var (vector-ref ret 6) ringbuf-num))
+		    500)
+    ret))
+
+(define (free-rb2 rb2)
+  (ringbuffer-stop (vector-ref rb2 5))
+  (rb2-return-buffer (vector-ref rb2 0))
+  (rb2-return-buffer (vector-ref rb2 1)))
+
+
+(define rb2-num-dropouts (make-var 0))
+
+(define-rt (read-rb2 rb2)
+  (let* ((read-pos-var (the <vct-*> (vector-ref rb2 2)))
+	 (read-pos (read-var read-pos-var))
+	 (size (read-var (vector-ref rb2 3)))
+	 (curr-ringbuffer-num (read-var (vector-ref rb2 4))))
+    (declare (<int> curr-ringbuffer-num read-pos size))
+    (if (= read-pos size)
+	(let ((ringbuffer (vector-ref rb2 5)))
+	  (if (= (read-var (vector-ref rb2 6)) curr-ringbuffer-num)
+	      (begin
+		(printf "RT-PLAYER: Error, can not read from disk fast enough.\\n");; Set the variable *rt-reader-buffer-time* higher.\\n"))
+		(write-var rb2-num-dropouts (1+ (read-var rb2-num-dropouts)))
+		(if (> (read-var rb2-num-dropouts) 3)
+		    (begin
+		      (printf "RT-PLAYER: Unable too read from disk fast enough. Stopping player.\\n")
+		      (remove-me))
+		    (if (and (< (- (read-var rt-snd-cursorupdate-inc) (read-var rt-snd-cursorupdate-dropout-num)) 4)
+			     (> (get-time) (+ (read-var rt-snd-cursorupdate-lasttime) 5)))
+			(begin
+			  (printf "RT-PLAYER: Too much cpu time spent. Stopping player. (2)\\n")
+			  (remove-me)))))
+	      (if (> (read-var rb2-num-dropouts) 0)
+		  (write-var rb2-num-dropouts (1- (read-var rb2-num-dropouts)))))
+	  (put-ringbuffer ringbuffer curr-ringbuffer-num)
+	  (set! curr-ringbuffer-num (if (= 0 curr-ringbuffer-num) 1 0))
+	  (write-var (vector-ref rb2 4) curr-ringbuffer-num)
+	  (set! read-pos 0)))
+    (let ((ret (vct-ref (vector-ref rb2 curr-ringbuffer-num) read-pos)))
+      (write-var read-pos-var (1+ read-pos))
+      ret)))
+
+
+
+
+;;(define (make-bigint
+
+
+(define *rt-loop-on-off* (make-var (if *c-islooping* 1 0)))
+(-> *loop-on-off-hook* add!
+    (lambda (on-off)
+      (write-var *rt-loop-on-off* (if on-off 1 0))))
+
+
+(eval-c (<-> "-I" snd-header-files-path)
+	"#include <config.h>"
+	"#include <xen.h>"
+	"#include <vct.h>"
+	
+	"extern Float protected_next_sample_to_float(void *sf)"
+	"extern Float protected_previous_sample_to_float(void *sf)"
+	
+	(public
+	 (<void> sample-reader->vct (lambda ((<SCM> scm_reader)
+					     (<SCM> scm_v)
+					     (<int> direction)
+					     (<int> startpos)
+					     (<int> num_samples))
+				      (<void-*> reader (cast <void-*> (SCM_SMOB_DATA scm_reader)))				      
+				      (<vct-*> v (cast <vct-*> (SCM_SMOB_DATA scm_v)))
+				      (if (|| (> (+ startpos num_samples) v->length)
+					      (< startpos 0))
+					  (printf (string "sample-reader->vct error. startpos: %d, num_samples: %d, vct-length: %d\\n") startpos num_samples v->length)
+					  (if (== 1 direction)
+					      (for-each startpos (+ startpos num_samples)
+							(lambda (i)
+							  (set! v->data[i] (protected_next_sample_to_float reader))))
+					      (for-each startpos (+ startpos num_samples)
+							(lambda (i)
+							  (set! v->data[i] (protected_previous_sample_to_float reader))))))))))
+
+
+(define rt-control-amp 0)
+(define rt-control-speed 1)
+(define rt-control-expand 2)
+(define rt-control-contrast 3)
+(define rt-control-reverb-scale 4)
+(define rt-control-reverb-length 5)
+
+(define (rt-set-controls! v snd)
+  (vct-set! v rt-control-amp (amp-control snd))
+  (vct-set! v rt-control-speed (speed-control snd))
+  (vct-set! v rt-control-expand (expand-control snd))
+  (vct-set! v rt-control-contrast (contrast-control snd))
+  (vct-set! v rt-control-reverb-scale (reverb-control-scale snd))
+  (vct-set! v rt-control-reverb-length (reverb-control-length snd)))
+
+(define rt-control-values (make-vct 20))
+
+(-> *c-control-hook* add!
+    (lambda ()
+      (let ((snd (c-selected-sound)))
+	(if snd
+	    (rt-set-controls! rt-control-values snd)))))
+
+(define (rt-set-defaults)
+  (let ((snd (c-selected-sound)))
+    (if snd
+	(rt-set-controls! rt-control-values (c-selected-sound))
+	(in 20 rt-set-defaults))))
+(rt-set-defaults)
+			  
+
+
+#!
+(< (abs (- 1.0 (vct-ref rt-control-values rt-control-speed))) 0.0000001)
+(vct-ref rt-control-values rt-control-speed)
+
+!#
+
+(define rt-controls-on-off (make-var 0))
+(->  *c-controls-on-off-hook* add!
+     (lambda ()
+       (let ((snd (c-selected-sound)))
+	 (if snd
+	     (write-var rt-controls-on-off (if (expand-control? snd) 1 0))))))
+
+
+(add-hook! graph-hook
+	     (lambda (snd chn y0 y1)
+	       (-> *c-controls-on-off-hook* run)
+	       (-> *c-control-hook* run)))
+	       
+
+(define (rt-snd-twofloats->int f1 f2)
+  (let ((i1 (c-integer f1))
+	(i2 (c-integer f2)))
+    (+ (ash i1 7) i2)))
+(define-rt (rt-snd-twofloats->int f1 f2)
+  (let ((i1 (the <int> f1))
+	(i2 (the <int> f2)))
+    (the <int> (+ (ash i1 7) i2))))
+
+;;(define (int->twofloats i)
+;;  (let ((i1 (ash i (- num-bits))))
+;;    (vct i1 (logand i (1- (expt 2 num-bits))))))
+
+(define rt-snd-rb2s '())
+
+(define rt-snd-bus (make-bus *rt-num-output-ports*))
+
+(define rt-snd-rt-safety-old (rt-safety))
+(set! (rt-safety) 0)
+
+(definstrument (<snd-rt-player> snd start das_end start-pos)
+  ;;(c-display start das_end start-pos)
+  (define num-channels #f)
+  (define end #f)
+  (define positions1 (vct 0))
+  (define positions2 (vct 0))
+  (define direction #f)
+  (define rb2s #f)
+  (define vcts #f)
+  (define size #f)
+  (define is-running (vct 0))
+  (define sound-src-ratio #f)
+  (define speed-gens #f)
+  (define expand-gens #f)
+  (define diskplaytype 0)
+  (define masterouttype 1)
+  (define (get-playfunc type position-in-queue fromdisk)
+    (<rt-play> #:position position-in-queue
+	       (lambda ()
+		 (declare (<int> fromdisk num-channels end size direction start))
+		 (let ((master-out (lambda ()
+				     (range i 0 ,*rt-num-output-ports*
+					    (out i (in i)))))
+		       (diskplay (lambda ()
+				   (let* ((volume (vct-ref rt-control-values rt-control-amp))
+					  (speed (/ (abs (vct-ref rt-control-values rt-control-speed)) sound-src-ratio))
+					  (expand (vct-ref rt-control-values rt-control-expand))
+					  (is-speeding (or (not (= 1 sound-src-ratio))
+							   (> (abs (- 1.0 speed)) 0.0000001)))
+					  (is-expanding (read-var rt-controls-on-off))
+					  (dont-read-anymore #f)
+					  (removefunc (lambda ()
+							(if fromdisk
+							    (range i 0 num-channels
+								   (let ((v (vector-ref rb2s i)))
+								     (ringbuffer-stop (vector-ref v 5)))))
+							(write-var is-running 0)
+							(set! dont-read-anymore #t)
+							(remove-me)))
+					  (read-position (lambda (i)
+							   (declare (<int> i))
+							   (the <int> (rt-snd-twofloats->int (vct-ref positions1 i)
+											     (vct-ref positions2 i)))))
+					  (set-position! (lambda (i val)
+							   (declare (<int> i val))
+							   (let ((i (the <int> i))
+								 (val (the <int> val)))
+							     (vct-set! positions1 i (ash val -7))
+							     (vct-set! positions2 i (logand val ,(1- (expt 2 7)))))))
+					  
+					  (changeposition (lambda (i)
+							    (declare (<int> i))
+							    (let ((i (the <int> i)))
+							      (if (= 1 direction)
+								  (begin
+								    (set-position! i (the <int> (1+ (read-position i))))
+								    (if (>= (read-position i) end)
+									(if (= 0 (read-var *rt-loop-on-off*))
+									    (removefunc)
+									    (set-position! i start))))
+								  (begin
+								    (set-position! i (the <int> (1- (read-position i))))
+								    (if (< (read-position i) start)
+									(if (= 0 (read-var *rt-loop-on-off*))
+									    (removefunc)
+									    (set-position! i (the <int> (1- end))))))))))
+					  (getdatafunc (lambda (i)
+							 (declare (<int> i))
+							 (if dont-read-anymore
+							     0.0
+							     (let ((ret (if fromdisk
+									    (read-rb2 (vector-ref rb2s i))
+									    (vct-ref (vector-ref vcts i) (- (read-position i) start)))))
+							       (changeposition i)
+							       ret))))
+					  (speedfunc (lambda (i)
+						       (declare (<int> i))
+						       (src (vector-ref speed-gens i)
+							    speed
+							    (lambda (dir)
+							      (getdatafunc i)))))
+					  (expandfunc (lambda (i)
+							(declare (<int> i))
+							(let ((expand-gen (vector-ref expand-gens i)))
+							  (setter!-mus-increment/mus_set_increment expand-gen (max 0.1 expand))
+							  (granulate expand-gen
+								     (lambda (dir)
+								       (if is-speeding
+									   (speedfunc i)
+									   (getdatafunc i))))))))
+				     (if (= 1 num-channels)
+					 (cond (is-expanding
+						(out (* volume (expandfunc 0))))
+					       (is-speeding
+						(out (* volume (speedfunc 0))))
+					       (else
+						(out (* volume (getdatafunc 0)))))
+					 (cond (is-expanding
+						(range i 0 num-channels
+						       (out i (* volume (expandfunc i)))))
+					       (is-speeding
+						(range i 0 num-channels
+						       (out i (* volume (speedfunc i)))))
+					       (else
+						(range i 0 num-channels
+						       (out i (* volume (getdatafunc i)))))))))))
+		   (if (= type diskplaytype)
+		       (diskplay)
+		       (master-out))))))
+  (if (not snd)
+      (get-playfunc masterouttype 'last #f)
+      (let ()
+	(define (cleanup-func rt)
+	  (lambda ()
+	    (-> rt stop)
+	    (if rb2s
+		(for-each (lambda (rb2)
+			    (free-rb2 rb2))
+			  ;;(ringbuffer-stop (vector-ref rb2 5)))
+			  (vector->list rb2s))
+		(for-each rb2-return-buffer (vector->list vcts)))))
+	(set! num-channels (channels snd))
+	(set! end (if das_end das_end (frames snd)))
+	(set! positions1 (make-vct num-channels (ash start-pos -7)))
+	(set! positions2 (make-vct num-channels (logand start-pos (1- (expt 2 7)))))
+	(set! direction (if (>= (speed-control snd) 0) 1 -1))
+	(set! rb2s #f)
+	(set! vcts #f)
+	(set! size (- end start))
+	(set! is-running (make-var 1))
+	(set! sound-src-ratio (/ (mus-srate) (srate snd)))
+	(set! speed-gens (apply vector (append (map (lambda (ch)
+						      (make-src #:srate 0.0 #:width (if (not (= 1 sound-src-ratio))
+											(max 40 (sinc-width))
+											(sinc-width))))
+						    (iota num-channels))
+					       (list snd))))
+	(set! expand-gens (apply vector (map (lambda (ch)
+					       (let ((ret (make-granulate  #:length 0.15 #:hop 0.03)))
+						 (set! (mus-location ret) 0)
+						 ret))
+					     (iota num-channels))))
+	
+	(if (or #f
+		(<= (- end start) (* 3 (mus-srate) *rt-reader-buffer-time*)))
+	    (begin
+	      ;;(c-display "direction" direction)
+	      (set! vcts (apply vector (map (lambda (ch)
+					      (let ((v (rb2-get-buffer size)))
+						(sample-reader->vct (make-sample-reader start snd ch direction) v 1 0 size)
+						v))
+					    (iota num-channels))))
+	      (let ((ret (get-playfunc diskplaytype 'first #f)))
+		(-> ret add-method 'cleanup-func (cleanup-func ret))
+		ret))
+	    (begin
+	      (set! rb2s (apply vector (map (lambda (ch)
+					      (if (= 1 direction)
+						  (let ((reader (make-sample-reader start-pos snd ch direction))
+							(position start-pos)
+							(size (c-integer (* (mus-srate) (+ (if #t
+											       0
+											       (+ (random 1.0) ;; To avoid all channels switching buffers at once.
+												  (/ num-channels 4)))
+											   *rt-reader-buffer-time*)))))
+						    (make-rb2 ch size
+							      (lambda (avct)
+								(let ((bytesleft (- end position)))
+								  (if (< bytesleft size)
+								      (begin
+									(sample-reader->vct reader avct direction 0 bytesleft)
+									(set! reader (make-sample-reader start snd ch direction))
+									(sample-reader->vct reader avct direction bytesleft (- size bytesleft))
+									(set! position (+ start (- size bytesleft))))
+								      (begin
+									(sample-reader->vct reader avct direction 0 size)
+									(set! position (+ position size))))))))
+						  (let ((reader (make-sample-reader start-pos snd ch direction))
+							(position start-pos)
+							(size (* (mus-srate) *rt-reader-buffer-time*)))
+						    (make-rb2 ch size
+							      (lambda (avct) ;; "position" is placed where to start reading next time. (this was tricky)
+								(let ((bytesleft (1+ (- position start))))
+								  (if (< bytesleft size)
+								      (begin
+									(sample-reader->vct reader avct direction 0 bytesleft)
+									(set! reader (make-sample-reader (1- end) snd ch direction))
+									(sample-reader->vct reader avct direction bytesleft (- size bytesleft))
+									(set! position (- (1- end) (- size bytesleft))))
+								      (begin
+									(sample-reader->vct reader avct direction 0 size)
+									(set! position (- position size))))))))))
+					    (iota num-channels))))
+	      (let ((ret (get-playfunc diskplaytype 'first #t)))
+		(-> ret add-method 'cleanup-func (cleanup-func ret))
+		ret))))))
+
+
+(set! (rt-safety) rt-snd-rt-safety-old)
+
+;;(define rt-snd-master-player (<snd-rt-player> #f #f #f #f #:in-bus rt-snd-bus))
+
+
+(define rt-snd-players '())
+
+(define (rt-snd-play snd start end start-pos)
+  (set! start-pos (min (frames snd) start-pos))
+  (set! rt-snd-players (cons (<snd-rt-player> snd start end start-pos) ; #:out-bus rt-snd-bus)
+			     rt-snd-players)))
+
+(define (rt-snd-stop-playing)
+  (for-each (lambda (player)
+	      (-> player cleanup-func))
+	    rt-snd-players)
+  (set! rt-snd-players '()))
+(define (rt-snd-stop player)
+  (-> player cleanup-func)
+  (set! rt-snd-players (remove (lambda (p) (eq? p player))
+			      rt-snd-players)))
+
+(define (rt-snd-get-player)
+  (if (null? rt-snd-players)
+      #f
+      (call-with-current-continuation
+       (lambda (return)
+	 (for-each (lambda (player)
+		     (if (= 1 (read-var (-> player is-running)))
+			 (return player)))
+		   rt-snd-players)
+	 (set! rt-snd-players '())
+	 #f))))
+      
+(define rt-snd-is-playing? rt-snd-get-player)
+
+(define (rt-snd-get-play-pos snd)
+  (let ((ret #f))
+    (for-each (lambda (player)
+		(let* ((channels (-> player num-channels))
+		       (player-snd (vector-ref (-> player speed-gens) channels)))
+		  (if (= snd player-snd)
+		      (if (or (not ret)
+			      (= 1 (read-var (-> player is-running))))
+			  (set! ret (rt-snd-twofloats->int (vct-ref (-> player positions1) 0)
+							   (vct-ref (-> player positions2) 0)))))))
+	      rt-snd-players)
+    (if ret
+	(c-integer ret)
+	ret)))
+
+(define rt-snd-cursorupdate-run #t)
+(define rt-snd-cursorupdate-interval 50)
+(define rt-snd-last-dropouts (-> *rt-engine* num_max_cpu_interrupts))
+(define rt-snd-cursorupdate-inc (make-var 0))
+(define rt-snd-cursorupdate-dropout-num (make-var 0))
+(define rt-snd-cursorupdate-lasttime (make-var (rte-time)))
+
+(define (rt-snd-cursorupdate)
+  (let ((player (rt-snd-get-player)))
+    (if player
+	(begin
+	  (if (not (= (if (>= (speed-control) 0) 1 -1)
+		      (-> player direction)))
+	      (let ((start (-> player start))
+		    (end (-> player end))
+		    (position (c-integer (vct-ref (-> player positions) 0))))
+		(rt-snd-play (c-selected-sound) start end position)
+		(rt-snd-stop player))
+	      (begin
+		(write-var rt-snd-cursorupdate-inc (1+ (read-var rt-snd-cursorupdate-inc)))
+		(if (> (read-var rt-snd-cursorupdate-inc) 100000)
+		    (write-var rt-snd-cursorupdate-inc 0))
+		(let ((pos (rt-snd-get-play-pos (c-selected-sound))))
+		  (if pos
+		      (let ((newdropouts (-> *rt-engine* num_max_cpu_interrupts)))
+			(if (not (= newdropouts rt-snd-last-dropouts))
+			    (begin
+			      (c-display "RT-PLAYER: Error, the player engine used too much CPU, so some processing was skipped.")
+			      (if (< (- (read-var rt-snd-cursorupdate-inc) (read-var rt-snd-cursorupdate-dropout-num)) 4)
+				  (begin
+				    (if (> (rte-time) (+ (read-var rt-snd-cursorupdate-lasttime) 5))
+					(begin
+					  (c-display "RT-PLAYER: Too much cpu time spent. Stopping player.")
+					  (rt-snd-stop-playing))))
+				  (write-var rt-snd-cursorupdate-lasttime (rte-time)))
+			      (write-var rt-snd-cursorupdate-dropout-num (read-var rt-snd-cursorupdate-inc))
+			      (set! rt-snd-last-dropouts newdropouts))
+			    (write-var rt-snd-cursorupdate-lasttime (rte-time)))
+			(set! (cursor) pos)
+			(c-show-times (cursor) #f)))))))))
+  (if rt-snd-cursorupdate-run
+      (in rt-snd-cursorupdate-interval
+	  rt-snd-cursorupdate)))
+
+(rt-snd-cursorupdate)
+
+
+
+
+
+
+	 
+#!
+(rt-snd-play 0 317544 492639 492639)
+
+(rt-clear-cache!)
+
+(set! (rt-safety) 0)
+(define p (<snd-rt-player> (selected-sound) 20000 #f (* 1 (mus-srate))))
+(set! (rt-safety) 1)
+
+(rte-info)
+(begin
+  (rte-silence!)
+  (ringbuffer-stop-all))
+
+(length rt-running-ringbuffers)
+
+(if (>= (vct-ref rt-control-values rt-control-speed) 0.0)  1 0)
+
+(vct-ref rt-control-values rt-control-speed)
+
+(rt-macroexpand '(vector-ref vec 5))
+(format #f "~A" '(vector))
+
+(set! (optimization) 6)
+
+(read-var *rt-loop-on-off*)
+(read-var rt-controls-on-off)
+(write-var rt-controls-on-off (if (expand-control?) 1 0))
+
+
+(macroexpand '(next-sample reader))
+
+(reverb-control-scale 0)
+
+(vct-ref rt-control-values rt-control-speed)
+
+(define r (make-sample-reader 200000 0 0 1))
+(begin r)
+(SCM_SMOB_DATA r)
+(dosomething r)
+(define rt-control-on-off (make-var 0))
+;;max buffer-size when buffring everything:
+(exact->inexact (/ (* 4 ;; bytes in a float
+		      3 ;; factor set for buffring all. Must be bigger than 2.
+		      *rt-reader-buffer-time*
+		      (mus-srate))
+		   1000000))
+
+
+(string= "abc" "abcd" 0 2 0 2)
+(string-drop "aiai.scm" 2)
+(string-take "cache.erm" 6)
+
+(define num-bits 8)
+(define (twofloats->int f1 f2)
+  (let ((i1 (c-integer f1))
+	(i2 (c-integer f2)))
+    (+ (ash i1 num-bits) i2)))
+(twofloats->int 1 6)
+(twofloats->int 2.0 9.0)
+
+(logand #b101 #b110)
+(1- (expt 2 num-bits))
+(begin #b1111)
+
+(define (int->twofloats i)
+  (let ((i1 (ash i (- num-bits))))
+    (vct i1 (logand i (1- (expt 2 num-bits))))))
+
+(int->twofloats 262)
+
+
+(ash 500000 23)
+
+(let ((player (car rt-snd-players)))
+  (list (rt-snd-twofloats->int (vct-ref (-> player positions1) 0)
+			       (vct-ref (-> player positions2) 0))
+	(vct-ref (-> player positions1) 0)
+	(vct-ref (-> player positions2) 0)))
+
+(logand 51233 (1- (expt 2 7)))
+
+!#
+
+
+
+
+
+
 ;; Load files from previous session.
   
 (if *c-restore-previous-session*
@@ -2117,6 +2734,9 @@
 
 
 
+
+
+
 ;;##############################################################
 ;; Try to make the window-size stay the same.
 ;; Seems to work for me at least.
@@ -2161,14 +2781,6 @@
 
 
 
-;;##############################################################
-;; Load rt-player. Takes some time.
-;;##############################################################
-
-(load-from-path "rt-player.scm")
-
-
-
 
 
 (set! *c-is-starting-up* #f)
diff -ur snd-8/snd-gmain.c snd-8-new/snd-gmain.c
--- snd-8/snd-gmain.c	2006-03-29 06:57:58.000000000 -0800
+++ snd-8-new/snd-gmain.c	2006-03-30 00:11:03.000000000 -0800
@@ -682,232 +682,7 @@
 	    {
 	      gtk_rc_parse_string("\n\
 \n\
-# This is the same as Snd.gtkrc\n\
-style \"default\"\n\
-{\n\
-  font_name = \"Serif 11\"\n\
 \n\
-  fg[NORMAL]      = { 0.0,  0.00, 0.0 }\n\
-  text[NORMAL]    = { 0.0,  0.0,  0.0 }\n\
-  bg[NORMAL]      = { 0.93, 0.93, 0.87 }\n\
-  bg[ACTIVE]      = { 0.80, 0.80, 0.75 }\n\
-  bg[INSENSITIVE] = { 0.93, 0.93, 0.87 }\n\
-  base[NORMAL]    = { 1.00, 1.00, 1.00 }\n\
-  bg[PRELIGHT]    = { 0.70, 0.70, 0.64 }\n\
-  fg[PRELIGHT]    = { 1.0,  0.0,  0.0}\n\
-\n\
-  GtkPaned::handle_size = 6\n\
-  GtkButton::default_border = { 0, 0, 0, 0 }\n\
-  GtkButton::default_outside_border = { 0, 0, 0, 0 }\n\
-  xthickness = 1\n\
-  ythickness = 1\n\
-}\n\
-\n\
-style \"default_button\" = \"default\"\n\
-{\n\
-#  bg[ACTIVE]   = { 0.79, 0.88, 1.0 }\n\
-#  bg[SELECTED] = { 0.79, 0.88, 1.0 }\n\
-}\n\
-\n\
-style \"default_menu\" = \"default\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-}\n\
-\n\
-style \"default_pane\" = \"default\"\n\
-{\n\
-  bg[NORMAL] = { 0.56, 0.93, 0.56 }\n\
-  bg[PRELIGHT] = { 0.26, 0.8, 0.26}\n\
-}\n\
-\n\
-style \"default_entry\" = \"default\"\n\
-{\n\
-  base[ACTIVE]      = { 0.93, 0.93, 0.87 }\n\
-  base[SELECTED]    = { 0.80, 0.80, 0.75 }\n\
-  base[PRELIGHT]    = { 1.0, 1.0, 1.0}\n\
-  base[NORMAL]      = { 0.93, 0.93, 0.87 }\n\
-  base[INSENSITIVE] = { 0.93, 0.93, 0.87 }\n\
-  bg[ACTIVE]        = { 1.0, 1.0, 1.0 }\n\
-  bg[SELECTED]      = { 1.0, 1.0, 1.0 }\n\
-  bg[PRELIGHT]      = { 1.0, 1.0, 1.0 }\n\
-  text[ACTIVE]      = { 0.0, 0.0, 0.0 }\n\
-  text[SELECTED]    = { 0.0, 0.0, 0.0 }\n\
-  text[PRELIGHT]    = { 0.0, 0.0, 0.0 }\n\
-}\n\
-\n\
-style \"default_text\" = \"default_entry\"\n\
-{\n\
-  base[NORMAL] = { 1.0, 1.0, 1.0 }\n\
-}\n\
-\n\
-style \"default_slider\" = \"default\"\n\
-{\n\
-  bg[NORMAL] = { 0.90, 0.90, 0.85 }\n\
-  bg[ACTIVE] = { 0.80, 0.80, 0.75 }\n\
-  bg[PRELIGHT] = { 0.70, 0.70, 0.64 }\n\
-\n\
-  GtkRange::slider_width = 13\n\
-  GtkRange::stepper_size = 10\n\
-}\n\
-\n\
-class \"GtkWidget\" style \"default\"\n\
-class \"GtkButton\" style \"default_button\"\n\
-class \"GtkMenu\" style \"default_menu\"\n\
-class \"GtkMenuBar\" style \"default_menu\"\n\
-class \"GtkEntry\" style \"default_entry\"\n\
-class \"GtkTextView\" style \"default_text\"\n\
-class \"GtkPaned\" style \"default_pane\"\n\
-class \"GtkRange\" style \"default_slider\"\n\
-\n\
-style \"zoom_slider\" = \"default_slider\"\n\
-{\n\
-  bg[NORMAL] = { 0.70, 0.70, 0.64 }\n\
-  bg[ACTIVE] = { 0.54, 0.54, 0.51 }\n\
-  bg[PRELIGHT] = { 0.44, 0.44, 0.36 }\n\
-\n\
-  GtkRange::slider_width = 12\n\
-  GtkRange::stepper_size = 12\n\
-}\n\
-\n\
-widget \"*.zx_slider\" style \"zoom_slider\"\n\
-widget \"*.zy_slider\" style \"zoom_slider\"\n\
-widget \"*.gzy_slider\" style \"zoom_slider\"\n\
-widget \"*.panel_button\" style \"zoom_slider\"\n\
-\n\
-style \"listener\" = \"default\"\n\
-{\n\
-  font_name = \"Monospace 10\"\n\
-\n\
-  base[NORMAL] = { 0.94, 0.97, 1.0 }\n\
-  text[NORMAL] = { 0.0, 0.0, 0.0 }\n\
-}\n\
-\n\
-widget \"*.listener_text\" style \"listener\"\n\
-\n\
-style \"help\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-  bg[PRELIGHT] = { 1.0, 1.0, 0.94 }\n\
-}\n\
-\n\
-widget \"*.help_button\" style \"help\"\n\
-\n\
-style \"quit\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-  bg[PRELIGHT] = { 1.0, 1.0, 0.94 }\n\
-}\n\
-\n\
-widget \"*.quit_button\" style \"quit\"\n\
-\n\
-style \"doit\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-  bg[PRELIGHT] = { 1.0, 1.0, 0.94 }\n\
-}\n\
-\n\
-widget \"*.doit_button\" style \"doit\"\n\
-\n\
-style \"doit_again\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-  bg[PRELIGHT] = { 1.0, 1.0, 0.94 }\n\
-}\n\
-\n\
-widget \"*.doit_again_button\" style \"doit_again\"\n\
-\n\
-style \"reset\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-  bg[PRELIGHT] = { 1.0, 1.0, 0.94 }\n\
-}\n\
-\n\
-widget \"*.reset_button\" style \"reset\"\n\
-widget \"*.the_unpane\" style \"default\"\n\
-style \"white_button\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 1.0 }\n\
-  bg[PRELIGHT] = { 0.94, 0.97, 1.0 }\n\
-  fg[PRELIGHT] = { 0.0,  0.0,  0.0}\n\
-  GtkButton::default-border = { 0, 0, 0, 0 }\n\
-  GtkButton::default_outside_border = { 0, 0, 0, 0 }\n\
-  GtkButton::focus_line_width = 0\n\
-  GtkButton::focus_padding = 0\n\
-  xthickness = 0\n\
-  ythickness = 0\n\
-}\n\
-\n\
-widget \"*.white_button\" style \"white_button\"\n\
-style \"env_button\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 0.94, 0.97, 1.0 }\n\
-  bg[INSENSITIVE] = { 0.94, 0.97, 1.0 }\n\
-  GtkButton::default_border = { 0, 0, 0, 0 }\n\
-  GtkButton::default_outside_border = { 0, 0, 0, 0 }\n\
-  GtkButton::focus_line_width = 0\n\
-  GtkButton::focus_padding = 0\n\
-  xthickness = 0\n\
-  ythickness = 0\n\
-}\n\
-\n\
-widget \"*.env_button\" style \"env_button\"\n\
-style \"label_button\" = \"default_button\"\n\
-{\n\
-  bg[NORMAL] = { 1.0, 1.0, 0.94 }\n\
-  bg[PRELIGHT] = { 1.0, 1.0, 0.94 }\n\
-  fg[PRELIGHT] = { 0.0,  0.0,  0.0}\n\
-\n\
-  GtkButton::default_border = { 0, 0, 0, 0 }\n\
-  GtkButton::default_outside_border = { 0, 0, 0, 0 }\n\
-  GtkButton::focus_line_width = 0\n\
-  GtkButton::focus_padding = 0\n\
-  xthickness = 0\n\
-  ythickness = 0\n\
-}\n\
-widget \"*.label_button\" style \"label_button\"\n\
-binding \"gtk-emacs-text-entry\"\n\
-{\n\
-  bind \"<ctrl>b\" { \"move-cursor\" (logical-positions, -1, 0) }\n\
-  bind \"<shift><ctrl>b\" { \"move-cursor\" (logical-positions, -1, 1) }\n\
-  bind \"<ctrl>f\" { \"move-cursor\" (logical-positions, 1, 0) }\n\
-  bind \"<shift><ctrl>f\" { \"move-cursor\" (logical-positions, 1, 1) }\n\
-  bind \"<alt>b\" { \"move-cursor\" (words, -1, 0) }\n\
-  bind \"<shift><alt>b\" { \"move-cursor\" (words, -1, 1) }\n\
-  bind \"<alt>f\" { \"move-cursor\" (words, 1, 0) }\n\
-  bind \"<shift><alt>f\" { \"move-cursor\" (words, 1, 1) }\n\
-  bind \"<ctrl>a\" { \"move-cursor\" (paragraph-ends, -1, 0) }\n\
-  bind \"<shift><ctrl>a\" { \"move-cursor\" (paragraph-ends, -1, 1) }\n\
-  bind \"<ctrl>e\" { \"move-cursor\" (paragraph-ends, 1, 0) }\n\
-  bind \"<shift><ctrl>e\" { \"move-cursor\" (paragraph-ends, 1, 1) }\n\
-  bind \"<ctrl>w\" { \"cut-clipboard\" () }\n\
-  bind \"<ctrl>y\" { \"paste-clipboard\" () }\n\
-  bind \"<ctrl>d\" { \"delete-from-cursor\" (chars, 1) }\n\
-  bind \"<alt>d\" { \"delete-from-cursor\" (word-ends, 1) }\n\
-  bind \"<ctrl>k\" { \"delete-from-cursor\" (paragraph-ends, 1) }\n\
-  bind \"<alt>backslash\" { \"delete-from-cursor\" (whitespace, 1) }\n\
-  bind \"<alt>space\" { \"delete-from-cursor\" (whitespace, 1)\n\
-                      \"insert-at-cursor\" (\" \") }\n\
-  bind \"<alt>KP_Space\" { \"delete-from-cursor\" (whitespace, 1)\n\
-                         \"insert-at-cursor\" (\" \")  }\n\
-  bind \"<ctrl>u\" {\n\
-     \"move-cursor\" (paragraph-ends, -1, 0)\n\
-     \"delete-from-cursor\" (paragraph-ends, 1)\n\
-  }\n\
-  bind \"<ctrl>h\" { \"delete-from-cursor\" (chars, -1) }\n\
-  bind \"<ctrl>w\" { \"delete-from-cursor\" (word-ends, -1) }\n\
-}\n\
-binding \"gtk-emacs-text-view\"\n\
-{\n\
-  bind \"<ctrl>p\" { \"move-cursor\" (display-lines, -1, 0) }\n\
-  bind \"<shift><ctrl>p\" { \"move-cursor\" (display-lines, -1, 1) }\n\
-  bind \"<ctrl>n\" { \"move-cursor\" (display-lines, 1, 0) }\n\
-  bind \"<shift><ctrl>n\" { \"move-cursor\" (display-lines, 1, 1) }\n\
-  bind \"<ctrl>space\" { \"set-anchor\" () }\n\
-  bind \"<ctrl>KP_Space\" { \"set-anchor\" () }\n\
-}\n\
-class \"GtkEntry\" binding \"gtk-emacs-text-entry\"\n\
-class \"GtkTextView\" binding \"gtk-emacs-text-entry\"\n\
-class \"GtkTextView\" binding \"gtk-emacs-text-view\"\n\
 ");
       }
 #endif
Only in snd-8-new: sndlib.h
